<template>
  <BasicModal v-bind="$attrs" @register="registerModal" destroyOnClose :title="title" :width="800" @ok="handleSubmit">
      <BasicForm @register="registerForm"/>
  </BasicModal>
</template>

<script lang="ts" setup>
    import {ref, computed, unref} from 'vue';
    import {BasicModal, useModalInner} from '/@/components/Modal';
    import {BasicForm, useForm} from '/@/components/Form/index';
    import {formSchema} from '../MetricTaskAlloc.data';
    import {saveOrUpdate,sendMessage} from '../MetricTaskAlloc.api';
    import { useMessage } from '/@/hooks/web/useMessage';
   
    const { createMessage } = useMessage();
    const emit = defineEmits(['register','success']);
    const isUpdate = ref(true);
    const mtrcNos = ref();
    type MessageObject = {
        [key: string]: string;
    };
    //表单配置
    const [registerForm, {setProps,resetFields, setFieldsValue, validate,removeSchemaByFiled}] = useForm({
        //labelWidth: 150,
        schemas: formSchema,
        showActionButtonGroup: false,
        baseColProps: {span: 24}
    });
    //表单赋值
    const [registerModal, {setModalProps, closeModal}] = useModalInner(async (data) => {
        //重置表单
        await resetFields();
        setModalProps({confirmLoading: false,showCancelBtn:!!data?.showFooter,showOkBtn:!!data?.showFooter});
        isUpdate.value = !!data?.isUpdate;
        if (unref(isUpdate)) {
            //表单赋值
            await setFieldsValue({
                ...data.record,
            });
        }
        if(data.mtrcNos) {
            removeSchemaByFiled("mtrcNo")
            removeSchemaByFiled("mtrcName")
            mtrcNos.value = data.mtrcNos
        }

        // 隐藏底部时禁用整个表单
       setProps({ disabled: !data?.showFooter })
    });
    //设置标题
    const title = computed(() => (!unref(isUpdate) ? '新增' : '编辑'));
    //表单提交事件
    async function handleSubmit() {
        try {
            let values = await validate();
            let tmpObj ={}
            if(mtrcNos.value) {
                tmpObj['mtrcNo'] = mtrcNos.value
            } else {
                tmpObj['mtrcNo'] = values.mtrcNo
            }
            tmpObj['id'] =values.taskIds
            if(!values.reporter) {
                createMessage.warning('请选择用户!');
                return 
            }
            tmpObj['reporter'] = values.reporter
            setModalProps({confirmLoading: true});
            //提交表单
            await saveOrUpdate(tmpObj, isUpdate.value);
            tmpObj['mtrcNo'] = "";
            mtrcNos.value = ""
            //关闭弹窗
            closeModal();
            //刷新列表
            emit('success');
            
        } finally {
            setModalProps({confirmLoading: false});

        }
    }

    // async function sentMyMessage() {
    //     const messagePatam: MessageObject = {
    //         templateCode: 'value1',
    //         templateName: 'value2',
    //         templateContent: 'value3',
    //         testData: 'value1',
    //         msgType: 'value2',
    //         receiver: 'value3'
    //     };
    //     await sendMessage(messagePatam) 
    // }
</script>

<style lang="less" scoped>
	/** 时间和数字输入框样式 */
  :deep(.ant-input-number){
		width: 100%
	}

	:deep(.ant-calendar-picker){
		width: 100%
	}
</style>